/*******************************************************************************
 *    : DlgApp.C
 *    : C ü
 *    : WinMain - Win32 Entry Point.
 *          WndProc - Windows Procedure.
 *    : ̾α׸   ̿ϴ ...
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.11.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
#include <windows.h>
#include "resource.h"

CHAR g_szAppName[] = "DlgAppEx";

LRESULT CALLBACK DlgProc(HWND, UINT, WPARAM, LPARAM);

/*******************************************************************************
 *    : WIN32 Ʈ Ʈ c
 *    : 
 *    : WinMain
 *    : HINSTANCE hInstance [IN] :  μ νϽ ڵ(۹)
 *          HINSTANCE hPrevInst [IN] :  0, (16Ʈ ȣȯ )
 *          PSTR      szCmdLine [IN] : Ŀǵ  з
 *          int       iCmdShow  [IN] : 찡  
 *   ȯ : int : 
 *    : WIN32 Ʈ Ʈ c
 *          ܼ α׷(main) ٸ GUI WinMain Ʈ Ʈ
 *          Լ νѴ.
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst,
                   PSTR szCmdLine, int iCmdShow)
{
	WNDCLASS     wndcls;


	////////////////////////////////////////////////////////////////////////////
	//  Ŭ 
	////////////////////////////////////////////////////////////////////////////
	wndcls.style         = CS_HREDRAW|CS_VREDRAW;
	wndcls.lpfnWndProc   = DlgProc;
	wndcls.cbClsExtra    = 0;
	wndcls.cbWndExtra    = DLGWINDOWEXTRA;
	wndcls.hInstance     = hInstance;
	wndcls.hIcon         = LoadIcon(hInstance, "DLGAPP.ICON");
	wndcls.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndcls.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndcls.lpszMenuName  = NULL;
	wndcls.lpszClassName = g_szAppName;
	if(!RegisterClass(&wndcls))
	{
		MessageBox(NULL, TEXT("Window Class Registeration Failure!!!"),
				  g_szAppName, MB_ICONERROR) ;
		return 0 ;
	}
	////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////
	// ̾α 
	////////////////////////////////////////////////////////////////////////////
	DialogBox(hInstance, 
		MAKEINTRESOURCE(IDD_DLG_MAIN), NULL, NULL);
	////////////////////////////////////////////////////////////////////////////

	return 0;
}
////////////////////////////////////////////////////////////////////////////////


/*******************************************************************************
 *    : ̾α ν Լ(ݹ Լ)
 *    : 
 *    : DlgProc
 *    : HWND   hWnd   [IN] : ޽   ڵ
 *          UINT   uMsg   [IN] : ޽
 *          WPARAM wParam [IN] : 1
 *          LPARAM lParam [IN] : 2
 *   ȯ : LRESULT : 
 *    : ̾α ν
 *          DialogBox lpfnDlgProc зͷ Լ  ѱ.
  * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
LRESULT CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_CREATE:
		return TRUE;

		case WM_COMMAND:
		{
			if(LOWORD(wParam) == IDOK)
			{
				EndDialog(hDlg, IDOK);
				return TRUE;
			}

			if(LOWORD(wParam) == IDM_EXIT)
			{
				if(MessageBox(hDlg, "Do you want to exit?", 
					"DlgAppEx", MB_YESNO|MB_ICONQUESTION) == IDYES)
				{
					EndDialog(hDlg, IDOK);
					return TRUE;
				}
			}
		}
		break;
	}

	return DefDlgProc(hDlg, uMsg, wParam, lParam);
}
////////////////////////////////////////////////////////////////////////////////