/*******************************************************************************
 *    : BasicApp.C
 *    : C ü
 *    : WinMain - Win32 Entry Point.
 *          WndProc - Windows Procedure.
 *    :    GUI ø̼ ...
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.11.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
#include <windows.h>
#include "Resource.h"

CHAR	g_szAppName		[256];
CHAR	g_szMessage		[256];
CHAR	g_szQuestion	[256];
CHAR	g_szFailRegCls	[256];
CHAR	g_szFileCreWnd	[256];

HACCEL	g_hAccel;
HBITMAP	g_hBmp;


LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

/*******************************************************************************
 *    : WIN32 Ʈ Ʈ c
 *    : 
 *    : WinMain
 *    : HINSTANCE hInstance [IN] :  μ νϽ ڵ(۹)
 *          HINSTANCE hPrevInst [IN] :  0, (16Ʈ ȣȯ )
 *          PSTR      szCmdLine [IN] : Ŀǵ  з
 *          int       iCmdShow  [IN] : 찡  
 *   ȯ : int : 
 *    : WIN32 Ʈ Ʈ c
 *          ܼ α׷(main) ٸ GUI WinMain Ʈ Ʈ
 *          Լ νѴ.
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst,
                   PSTR szCmdLine, int iCmdShow)
{
	HWND         hWnd;
	MSG          msg;
	WNDCLASS     wndclass;

	g_hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCEL));
	LoadString(hInstance, IDS_APPNAME,  g_szAppName, sizeof(g_szAppName));
	LoadString(hInstance, IDS_MESSAGE,  g_szMessage, sizeof(g_szMessage));
	LoadString(hInstance, IDS_QUESTION, g_szQuestion, sizeof(g_szQuestion));
	LoadString(hInstance, IDS_FAIL_REGISTER_CLASS, 
							g_szFailRegCls, sizeof(g_szFailRegCls));
	LoadString(hInstance, IDS_FAIL_CREATE_WINDOW, 
							g_szFileCreWnd, sizeof(g_szFileCreWnd));


	////////////////////////////////////////////////////////////////////////////
	// Ŭ 
	////////////////////////////////////////////////////////////////////////////
	wndclass.style         = CS_HREDRAW|CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor(hInstance, MAKEINTRESOURCE(IDR_CURSOR));
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU);
	wndclass.lpszClassName = g_szAppName;
	if(!RegisterClass(&wndclass))
	{
		MessageBox(NULL, g_szFailRegCls, g_szAppName, MB_ICONERROR);
		return 0 ;
	}
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// & 
	////////////////////////////////////////////////////////////////////////////
	hWnd = CreateWindow(g_szAppName,			// window class name
						g_szAppName,			// window caption
						WS_OVERLAPPEDWINDOW,	// window style
						CW_USEDEFAULT,			// initial x position
						CW_USEDEFAULT,			// initial y position
						400,					// initial x size
						150,					// initial y size
						NULL,					// parent window handle
						NULL,					// window menu handle
						hInstance,				// program instance handle
						NULL) ;					// creation parameters
	if(!hWnd)
	{
		MessageBox(NULL, g_szFileCreWnd, g_szAppName, MB_ICONERROR);
		return 0 ;
	}
	ShowWindow(hWnd, iCmdShow);
	UpdateWindow(hWnd);
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	//޽ 
	////////////////////////////////////////////////////////////////////////////
	while(GetMessage(&msg, NULL, 0, 0))
	{
        if(!TranslateAccelerator(hWnd, g_hAccel, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	////////////////////////////////////////////////////////////////////////////

	return msg.wParam;
}
////////////////////////////////////////////////////////////////////////////////


/*******************************************************************************
 *    :  ν Լ(ݹ Լ)
 *    : 
 *    : WndProc
 *    : HWND   hWnd   [IN] : ޽   ڵ
 *           UINT   uMsg   [IN] : ޽
 *           WPARAM wParam [IN] : 1
 *           LPARAM lParam [IN] : 2
 *   ȯ : LRESULT : 
 *    :  ν
 *           WINDOWCLASS lpfnWndProc ʵ忡  Լ  ؾ.
 *              Լ  ƮѴ.
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HDC         hDC;
	PAINTSTRUCT ps;
	RECT        rc;

	switch(uMsg)
	{
		case WM_COMMAND	:
		{
			WORD wID = LOWORD(wParam);
			switch(wID)
			{
				case ID_MENU_CHANGECURSOR  :
				case ID_ACCEL_CHANGECURSOR :
				{
					HMENU hSubMenu = GetSubMenu(GetMenu(hWnd), 0);
                    UINT uFlag = GetMenuState(hSubMenu, 0, MF_BYPOSITION);
					if(uFlag & MF_CHECKED)
					{
						SetClassLong(hWnd, GCL_HCURSOR, 
							(LONG)LoadCursor(NULL, IDC_ARROW));
						CheckMenuItem(hSubMenu, 0, MF_BYPOSITION|MF_UNCHECKED);
					}
					else
					{
						SetClassLong(hWnd, GCL_HCURSOR, 
							(LONG)LoadCursor(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_CURSOR))); 
						CheckMenuItem(hSubMenu, 0, MF_BYPOSITION|MF_CHECKED);
					}
				}
				break;

				case ID_MENU_SHOWBITMAP	 :
				case ID_ACCEL_SHOWBITMAP :
				{
					if(!g_hBmp)
					{
						HMENU hm1 = GetSubMenu(GetMenu(hWnd), 0);
						HMENU hm2 = GetSubMenu(hm1, 2);
						EnableMenuItem(hm2, 0, MF_BYPOSITION|MF_GRAYED);
						EnableMenuItem(hm2, 1, MF_BYPOSITION|MF_ENABLED);

						g_hBmp = LoadBitmap(GetModuleHandle(NULL), 
										MAKEINTRESOURCE(IDR_BITMAP));
						InvalidateRect(hWnd, NULL, TRUE);
					}
				}
				break;

				case ID_MENU_CLEARBITMAP  :
				case ID_ACCEL_CLEARBITMAP :
				{
					if(g_hBmp)
					{
						HMENU hm1 = GetSubMenu(GetMenu(hWnd), 0);
						HMENU hm2 = GetSubMenu(hm1, 2);
						EnableMenuItem(hm2, 0, MF_BYPOSITION|MF_ENABLED);
						EnableMenuItem(hm2, 1, MF_BYPOSITION|MF_GRAYED);

						DeleteObject(g_hBmp);
						g_hBmp = NULL;
						InvalidateRect(hWnd, NULL, TRUE);
					}
				}
				break;

				case ID_MENU_EXIT  :
				case ID_ACCEL_EXIT :
				{
					if(MessageBox(hWnd, g_szQuestion, g_szAppName, 
									MB_YESNO|MB_ICONQUESTION) == IDYES)
						DestroyWindow(hWnd);
				}
				break;
			}
		}
		return 0;

		case WM_PAINT	:
		{
			HBRUSH hbr = NULL, hOldBr = NULL;
			hDC = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rc);
			if(g_hBmp)
			{
				hbr = CreatePatternBrush(g_hBmp);
				hOldBr = (HBRUSH)SelectObject(hDC, hbr);
				PatBlt(hDC, 0, 0, rc.right, rc.bottom, PATCOPY);
			}
			else
			{
				hbr = CreateSolidBrush(RGB(255, 255, 255));
				FillRect(hDC, &rc, hbr);
			}

			INT nOldBkMode = SetBkMode(hDC, TRANSPARENT);
			DrawText(hDC, 
					 g_szMessage, 
					 lstrlen(g_szMessage), 
					 &rc, 
					 DT_SINGLELINE|DT_CENTER|DT_VCENTER);
			SetBkMode(hDC, nOldBkMode);
			if(g_hBmp)
			{
				SelectObject(hDC, hOldBr);
				DeleteObject(hbr);
			}
			EndPaint (hWnd, &ps) ;
		}
		return 0;

		case WM_DESTROY	:
		{
			if(g_hBmp)
			{
				DeleteObject(g_hBmp);
				g_hBmp = NULL;
			}
			PostQuitMessage(0);
		}
		return 0;
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
////////////////////////////////////////////////////////////////////////////////
